	program Astronomical_Tide
      implicit real*8 (a-h,o-z)

	
C	More information about the code can be found in Vries et al. 1995, (Environ Softw), 
C	Krestenitis et al, 2011 (J. Coastal Management), Androulidakis et al 2015 (Dynamics of Oceans and Atmospheres)
C     SOLUTION OF THE 2DH TIDAL-WIND GENERATED CIRCULATION IN A COASTAL      
C     BASIN WITH COASTAL AND/OR OPEN SEA BOUNDARY CONDITIONS

      DIMENSION H(500,500),U(500,500),UN(500,500),V(500,500),cs(500,500)
     & ,VN(500,500),Z(500,500),WINX(800),WINY(800),ED(500,500)
     &,zz(500,500),
     & CB(500,500),VOR(500,500),URES(500,500),VRES(500,500),w(500,500)
      DIMENSION SXX(500,500),SXY(500,500),SYY(500,500),mask(500,500)
	integer n,day,t,tw,mon,twind,thour,iy,NN,dayf
	real*4 pp,hww
	   character*2 hh,mm,hhh
           character*3 ddd,yy,dddd
      character*8 ddate
		 integer date_time(8)
       character*10 b(3)
	real*8 kM2,Date,sM2,ho,so,xM2
        real*8 kS2,kN2,kK2,sS2,sN2,sK2,xS2,xN2,xK2
        real*8 zM2,zN2,zS2,zK2,tlon,tlat
        real*8 kK1,kO1,kP1,kQ1,sK1,sO1,sP1,sQ1,xK1,xO1,xP1,xQ1
        real*8 zK1,zO1,zP1,zQ1
		
c	parameter (im=431,jm=156)

	dimension alat(500,500),alon(500,500),radlat(500,500),cf(500,500)
	dimension dx(500,500),dy(500,500),wx(500,500),wy(500,500)
	dimension tsx(500,500),tsy(500,500),slp(500,500),slp1(500,500)
	dimension tsxx(500,500),tsyy(500,500),zt(500,500)
	dimension sumz(500,500),zmeso(500,500),icoast(5000),jcoast(5000)
	DIMENSION F(500),HHo(500)
	character*5 TIDE
	CHARACTER*20 FNAME
      CHARACTER*2000 path
   	
	pi=3.1415926535897932
	im=302
	jm=106
c	******************Calculation of current year, month, day, hour, minute
	
       call date_and_time(b(1), b(2), b(3), date_time)
       print *,'date_time    array values:'
       print *,'year=',date_time(1)
       print *,'month_of_year=',date_time(2)
       print *,'day_of_month=',date_time(3)
       print *,'time difference in minutes=',date_time(4)
       print *,'hour of day=',date_time(5)
       print *,'minutes of hour=',date_time(6)
       print *,'seconds of minute=',date_time(7)
       print *,'milliseconds of second=',date_time(8)
       print *, 'DATE=',b(1)
       print *, 'TIME=',b(2)
       print *, 'ZONE=',b(3)


		if(date_time(2).eq.2)then
        startday=31+date_time(3)
        elseif(date_time(2).eq.3)then
        startday=59+date_time(3)
c       write(*,*)startday
c       pause
        elseif(date_time(2).eq.4)then
        startday=90+date_time(3)
        elseif(date_time(2).eq.5)then
        startday=120+date_time(3)
        elseif(date_time(2).eq.6)then
        startday=151+date_time(3)
        elseif(date_time(2).eq.7)then
        startday=181+date_time(3)
        elseif(date_time(2).eq.8)then
        startday=212+date_time(3)
        elseif(date_time(2).eq.9)then
        startday=243+date_time(3)
        elseif(date_time(2).eq.10)then
        startday=273+date_time(3)
         elseif(date_time(2).eq.11)then
        startday=304+date_time(3)
        elseif(date_time(2).eq.12)then
        startday=334+date_time(3)
        endif

	hourcur=date_time(5)
	iy=date_time(1)

	 open(898,file='Seconds.dat')   !Number of seconds from the first day of the year
       read(898,*)NU					  !e.g. 3 January 2015 00:00 --> NU=2 days * 86400 = 172800
       close(898)

c****************tidal parameters (Schwiderski 1980)

	  kM2=0.242334

        sM2=0.000140519


        kS2=0.112841

        sS2=0.000145444


        kN2=0.046398

        sN2=0.000137880


        kK2=0.030704

        sK2=0.000145842


        kK1=0.141565

        sK1=0.000072921


        kO1=0.100514

        sO1=0.000067598


        kP1=0.046843

        sP1=0.000072523


        kQ1=0.019256

        sQ1=0.000064959

	
	

	 dt=3.		!DT=TIME	STEP	OF	THE	NUMERICAL	INTEGRATION
	 NM=28800.	!NM=NUMBER	OF	TIME	STEPS (NM=days*86400/dt - set the end of simulation)
	 zo=0.01	!ZO=SEA	BED	ROUGHNESS
	 ccc=0.1	!CONSTANT	OF	THE	HORIZONTAL	EDDY	VISCOSITY	COEFF.	
	 edd=5.		!EDD=MIN	VALUE	OF	THE	EDDY	VISCOSITY	COEFFICIENT
	 zino=0
	 zinu=0
	 zinl=0
	 zinr=0		!AMPLITUDES	OF	THE	TIDAL	COMPONENTS	ALONG	THE	LOWER	UPPER	LEFT	AND	RIGHT	OPEN	SEA	BOUNDARIES	(IF	ANY)
	 pero=10.
	 peru=10.
	 perl=10.
	 perr=10.	!PERIODS	OF	THE	CORRESPONDING	TIDAL	SIGNALS

        
	
	

***********************
C     OPENING OF THE DEPTH DATA FILE AND INPUT OF THE DEPTH H(I,J) VALUES
C     REFERING TO THE CENTER OF EACH NODE
	open(60,file='Bathymetry.dat')
C	Bathymetry file must include the following format, where alon, alat, dx, dy and h are the longitude,latitude, x-grid size(m), y-grid size(m) and depth(m), respectively.  
	do jj=1,jm
	do ii=1,im
      read(60,*) i,j,alon(i,j),alat(i,j),dx(i,j),dy(i,j),h(i,j) 
	enddo
	enddo


	
C	*******Compute Coriolis force	
	do j=1,jm-1
	do i=1,im-1
	
	radlat(i,j)=alat(i,j)*pi/180
	wom=2*pi/(24*3600)
	cf(i,j)=2*wom*sin(radlat(i,j))

	enddo
	enddo



3000	format('Thessaloniki')
3001	format('Thessaloniki_U',x,'Thessaloniki_V')


      DO 471 J=1,JM
      DO 471 I=1,IM
      URES(I,J)=0.
  471 VRES(I,J)=0.

C	*****************************
c     COMPUTATION OF THE BED FRICTION COEFFICIENTS CB(I,J) ACCORDING TO
C     THE ZO AND LOCAL DEPTH VALUES
      DO 555 J=1,JM-1
      DO 555 I=1,IM-1
      IF(H(I,J).GT.1) GOTO 556 
      CB(I,J)=0.
      GOTO 555
  556 CB(I,J)=(.4/(DLOG(H(I,J)/ZO)-1.))**2
c      if(H(i,j).gt.250) H(i,j)=250
  555 CONTINUE
c	*********************************
		
	! Open output files at stations
	 open(10,file='Stations_Tidal_Elevations.dat')
       write(10,3000) 
	 open(11,file='Stations_Tidal_Currents.dat')
       write(11,3001) 
	

	N=0

	T=0
C     ALOCATION OF THE MIN EDDY VALUES TO THE EDDY VISCOSITY MATRIX
      DO 445 J=1,JM-1
      DO 445 I=1,IM-1
  445 ED(I,J)=EDD3

c	if(nmm.eq.1) goto 450


      do i=1,im  
      do j=1,jm  
      u(i,j)=0.0;v(i,j)=0.0;z(i,j)=0.0  
      enddo  
      enddo  
	



	do j=1,jm
	do i=1,im
	wx(i,j)=0
	wy(i,j)=0
	slp(i,j)=0
	enddo
	enddo
	

c******Calcualtion of Sea surface Drag Coefficiant by Smith&Banke,1975***

	
	
	do i=1,im-1
	do j=1,jm-1
	
	w(i,j)=SQRT(wx(i,j)**2+wy(i,j)**2)
	cs(i,j)=1.2/1025*(0.63+0.066*w(i,j))/10**3


	enddo
	enddo

	do i=1,im-1
	do j=1,jm-1

      TSX(i,j)=CS(i,j)*WX(i,j)*SQRT(WX(i,j)**2+WY(i,j)**2)
      TSY(i,j)=CS(i,j)*WY(i,j)*SQRT(WX(i,j)**2+WY(i,j)**2)


	enddo
	enddo

****************************Start Numerical  Integration*********************
  100 N=N+1
 
      T=T+DT

	dayz=N*dt/86400
	hww=float(t)/3600
      
       
        hw=T-3600*int(t/3600)
        if(hww.eq.int(hww)) then
        hhh=char(int(hww/10)+48)//char(int(hww-10*int(hww/10)+48))
	  endif
        


c	*********************************************
C     SOLUTION OF THE CONTINUITY EQUATION FOR THE COMPUTATION OF THE NEW
C     Z(I,J) VALUES IN THE MESH CENTERS
      DO 30 J=2,JM-2
      DO 30 I=2,IM-2


      IF(H(I,J).GT.1) GOTO 460
      Z(I,J)=0.
      GOTO 30
  460 CONTINUE
C     BLOCK FOR THE OPEN SEA BOUNDARY CONDITIONS. 
c	IF THE TIDAL COMPONENT IS NONZERO ON THAT BOUNDARY THE INCOMING AND 
c	RADIATED SIGNALS ARE SUPERIMPOSED. 
c	IF THE TIDAL COMPONENT IS ZERO THE RADIATED SIGNAL ONLY IS ESTIMATED
      IF((J.EQ.2).AND.(H(I,1).GT.1)) GOTO 110
      IF((J.EQ.JM-2).AND.(H(I,JM-1).GT.1)) GOTO 120
      IF((I.EQ.2).AND.(H(2,J).GT.1)) GOTO 130
      IF((I.EQ.IM-2).AND.(H(IM-1,J).GT.1)) GOTO 140


c	write(*,*)i,j,z(i,j),u(i,j),v(i,j)
c	pause

*************************************************
	
	z(i,j) = z(i,j)-dt*(((h(i+1,j)+h(i,j))*u(i+1,j)
     &                    -(h(i,j)+h(i-1,j))*u(i,j))/dx(i,j)
     &                    +((h(i,j+1)+h(i,j))*v(i,j+1)
     &                    -(h(i,j)+h(i,j-1))*v(i,j))/dy(i,j))*.5




      IF(ABS(Z(I,J)).LT..0000001) Z(I,J)=0.

      GOTO 30
  110 IF(ZINU.LT..01) GOTO 111
      CC=SQRT(9.81*H(I,J))
      EL=PERU*CC
	
      Z(I,J)=Z(I,J)+ZINU*SIN(6.2832*DT/PERU)*COS(6.2832*N*DT/PERU)+
     & CC*DT/DX(I,J)*(Z(I,J+1)-Z(I,J)+ZINU*SIN(6.2832*
     & DX(i,j)/EL)*COS(6.2832*(N-1)*DT/PERU))
      GOTO 30

  111 Z (I,J)=-V(I,J+1)*SQRT(H(I,J)/9.81)+(1012*100
     & -SLP(I,J))/(9.81*1025)
	


      GOTO 30
  120 IF(ZINO.LT..01) GOTO 121

      CC=SQRT(9.81*H(I,J))
      EL=CC*PERO
	
      Z(I,J)=Z(I,J)+ZINO*SIN(6.2832*DT/PERO)*COS(6.2832*N*DT/PERO)+
     & CC*DT/DX(i,j)*(Z(I,J-1)-Z(I,J)+ZINO*SIN(6.2832*
     & DX(i,j)/EL)*COS(6.2832*(N-1)*DT/PERO))
      GOTO 30

  121 Z (I,J)=V(I,J)*SQRT(H(I,J)/9.81)+(1012*100
     & -SLP(I,J))/(9.81*1025)
	
	
      GOTO 30

  130 IF(ZINL.LT..01) GOTO 131
	CC=SQRT(9.81*H(I,J))
      EL=CC*PERL

  	Z(I,J)=Z(I,J)+ZINL*SIN(6.2832*DT/PERL)*COS(6.2832*N*DT/PERL)+
     & CC*DT/DX(i,j)*(Z(I,J-1)-Z(I,J)+ZINL*SIN(6.2832*
     & DX(i,j)/EL)*COS(6.2832*(N-1)*DT/PERL))
     
  131	Z (I,J)=-U(I,J)*SQRT(H(I,J)/9.81)+(1012*100
     & -SLP(I,J))/(9.81*1025)

	

      GOTO 30

  140 IF(ZINR.LT..01) GOTO 141 
      CC=SQRT(9.81*H(I,J))
      EL=CC*PERR
	
      Z(I,J)=Z(I,J)+ZINR*SIN(6.2832*DT/PERR)*COS(6.2832*N*DT/PERR)+
     & CC*DT/DX(i,j)*(Z(I-1,J)-Z(I,J)+ZINR*SIN(6.2832*
     & DX(i,j)/EL)*COS(6.2832*(N-1)*DT/PERR))
      GOTO 30

 141  Z(I,J)=-U(I,J)*SQRT(H(I,J)/9.81)+(1012*100
     & -SLP(I,J))/(9.81*1025)

	

   30 CONTINUE


	startime=hourcur+T/3600  

        ty=iy

        td=startday+startime/24.

        Date=td+365.*(ty-1975)+int((ty-1973)/4)

        TTi=(27392.500528+1.0000000356*Date)/36525.

        ho=279.69668+36000.168930485*TTi+0.000303*TTi**2

        so=270.434358+481267.88314137*TTi-
     &0.00133*TTi**2+0.0000019*TTi**3

        po=334.329653+4069.0340329575*TTi-
     &0.010325*TTi**2-0.000012*TTi**3

         xM2=(2*ho-2*so)*pi/180.

        xS2=0

        xN2=(2*ho-3*so+po)*pi/180.

        xK2=2*ho*pi/180.

          xK1=(ho+90)*pi/180.

        xO1=(ho-2*so-90)*pi/180.

        xP1=(ho-90)*pi/180.

        xQ1=(ho-3*so+po-90)*pi/180.

c        TTi=TTi*86400.*36525.


	   DO J=1,JM
         DO I=1,IM


        tlon=(alon(i,j)+alon(i+1,j))/2.*pi/180.
        tlat=(alat(i,j)+alat(i,j+1))/2.*pi/180.


        if(H(i,j).eq.1)then
        zt(i,j)=0.0
c	pause
        else
        zM2=kM2*(sin(tlat)**2)*cos(sM2*(T+NU)+xM2+2*tlon)

        zS2=kS2*(sin(tlat)**2)*cos(sS2*(T+NU)+xS2+2*tlon)

        zN2=kM2*(sin(tlat)**2)*cos(sN2*(T+NU)+xN2+2*tlon)

        zK2=kK2*(sin(tlat)**2)*cos(sK2*(T+NU)+xK2+2*tlon)

        zK1=kK1*sin(2*tlat)*cos(sK1*(T+NU)+xK1+tlon)

        zO1=kO1*sin(2*tlat)*cos(sO1*(T+NU)+xO1+tlon)

        zP1=kP1*sin(2*tlat)*cos(sP1*(T+NU)+xP1+tlon)

        zQ1=kQ1*sin(2*tlat)*cos(sQ1*(T+NU)+xQ1+tlon)

        zt(i,j)=zM2+zS2+zN2+zK2+zK1+zO1+zP1+zQ1

	
	endif

c	write(1212,*)alon(i,j),alat(i,j),zt(i,j)

	enddo
	enddo
	

c	write(*,*)T,zt(135,101),h(135,101)

c      pause
c	******************************************************
	
C     SOLUTION OF THE EQUILIBRIUM EQUATION ALONG X AXIS FOR THE COMPUTATION
C     OF THE NEW U(I,J) COMPONENT ALONG THE MESH SIDES 
      DO 150 J=2,JM-2
      DO 150 I=3,IM-2

      IF((H(I-1,J).LT.2).OR.(H(I,J).LT.2)) GOTO 160
      GOTO 170
  160 UN(I,J)=0.
      GOTO 150
  170 HM=(H(I,J)+H(I-1,J))/2.
	TSXX(I,J)=0.5*(TSX(I,J)+TSX(I-1,J))

      VV=(V(I,J)+V(I-1,J)+V(I,J+1)+V(I-1,J+1))/4.
      CBB=(CB(I,J)+CB(I-1,J))/2.
      FRICT=CBB*U(I,J)*SQRT(U(I,J)**2+VV**2)
      DD=(ED(I,J)+ED(I,J+1))/2.

      ADVX=U(I,J)*(U(I+1,J)-U(I-1,J))/2./DX(i,j)				  
      ADVY=VV*(U(I,J+1)-U(I,J-1))/2./Dy(i,j)
	


	if((frict.gt.100000)) then
	write(*,*)'FRICT=',n, i,j,FRICT,z(i,j),zt(i,j)
	pause
	endif


	RAD=0	
	
 

      UN(I,J)=U (I,J)-DT*(RAD+ADVX+ADVY+9.81*(0.9*(Z(I,J)-Z(I-1,J))-0.7
     &*(zt(i,j)-zt(i-1,j)))/DX(i,j)
     &-CF(i,j)*VV+(slp(i,j)-slp(i-1,j))/(DX(I,J)*1025)
     & +FRICT/HM-TSXX(i,j)/HM-DD *(U (I+1,J)+U (I-1,J)+U (I,J+1)+U (I,
     & J-1)-4.*U (I,J))/(DX(i,j)*DY(I,J)))




      IF(ABS(UN(I,J)).LT..000001) UN(I,J)=0.
  
c	pause
  150 CONTINUE

c	pause
C     OPEN SEA BOUNDARY CONDITIONS OF ZERO VELOCITY GRADIENTS
      DO 180 J=2,JM-2
      IF(H(1,J).LT.2) GOTO 190
      UN(2,J)=UN(3,J)
  190 IF(H(IM-1,J).LT.2) GOTO 180
      UN(IM-1,J)=UN(IM-2,J)
  180 CONTINUE
      DO 200 I=2,IM-1
      IF((H(I,1).LT.2).OR.(H(I-1,1).LT.0.1)) GOTO 210
	UN(I,1)=UN(I,2)
  210 IF((H(I,JM-1).LT.2).OR.(H(I-1,JM-1).LT.2)) GOTO 200
      UN(I,JM-1)=UN(I,JM-2)
  200 CONTINUE
	
C     SOLUTION OF THE EQUILIBRIUM EQUATION ALONG Y FOR THE COMPUTATION OF
C     V(I,J) COMPONENTS ALONG THE MESH SIDES
      DO 250 J=3,JM-2
      DO 250 I=2,IM-2
      IF((H(I,J).LT.2).OR.(H(I,J-1).LT.2)) GOTO 260
      GOTO 270
  260 VN(I,J)=0.
      GOTO 250
  270 HM=(H(I,J)+H(I,J-1))/2.
      TSYY(I,J)=0.5*(TSY(I,J)+TSX(I,J-1))
      UU=(U(I,J)+U(I+1,J)+U(I,J-1)+U(I+1,J-1))/4.
      CBB=(CB(I,J)+CB(I,J-1))/2.
      FRICT=CBB*V(I,J)*SQRT(V(I,J)**2+UU**2)
      DD=(ED(I,J)+ED(I+1,J))/2.

      ADVX=UU*(V(I+1,J)-V(I-1,J))/2./DX(i,j)
      ADVY=V(I,J)*(V(I,J+1)-V(I,J-1))/2./DY(i,j)
	

	RAD=0	

	

      VN(I,J)=V(I,J)-DT*(RAD+CF(i,j)*UU+9.81*(0.9*(Z(I,J)-Z(I,J-1))-0.7
     &*(zt(i,j)-zt(i,j-1)))/DY(i,j)
     &+FRICT/HM + (slp(i,j)-slp(i,j-1))/(DY(I,J)*1025)
     & -TSYY(i,j)/HM-DD *(V (I,J+1)+V (I,J-1)+V (I+1,J)+V (I-1,J)-4*
     & V (I,J))/(DX(i,j)*DY(I,J))+ADVX+ADVY)




      IF(ABS(VN(I,J)).LT..000001) VN(I,J)=0.
  250 CONTINUE

	
C     OPEN BOUNDARY CONDITIONS OF ZERO VELOCITY GRADIENTS
      DO 280 I=2,IM-2
      IF(H(I,1).LT.2) GOTO 290
      VN(I,2)=  VN(I,3)
  290 IF(H(I,JM-1).LT.2) GOTO 280
      VN(I,JM-1)=VN(I,JM-2)
  280 CONTINUE
      DO 305 J=2,JM-1
      IF((H(1,J).LT.2).OR.(H(1,J-1).LT.2)) GOTO 310
      VN(1,J)=VN(2,J)
  310 IF((H(IM-1,J).LT.2.).OR.(H(IM-1,J-1).LT.2.)) GOTO 305
      VN(IM-1,J)=VN(IM-2,J)
  305 CONTINUE
      DO 400 J=1,JM-1
      DO 400 I=1,IM-1
      V(I,J)=VN(I,J)
  400 U(I,J)=UN(I,J)
C     COMPUTATION OF THE EDDY VISCOSITY DISTRIBUTION ACCORDING TO 
C     SMAGORINSKY ED=CCC*DX**2*NORM(GRAD(VORTICITY)))
      DO 444 J=2,JM-2
      DO 444 I=2,IM-2
      VOR(I,J)=(U(I,J)-U(I,J-1))/dy(i,j-1)-(V(I,J)-V(I-1,J)/dx(i-1,j))
  444 CONTINUE

	
      DO 4451 J=2,JM-2
      DO 4451 I=2,IM-2



      
      ED(I,J)=SQRT((VOR(I+1,J)-VOR(I-1,J))**2+(VOR(I,J+1)-VOR(I,J-1))
     & **2)*DX(i,j)*DY(i,j)*CCC

      IF(ED(I,J).LT.EDD) ED(I,J)=EDD

	

 4451 CONTINUE
      IF(N.LT.NM/2) GOTO 714
      DO 715 J=1,JM-1
      DO 715 I=1,IM-1
      URES(I,J)=URES(I,J)+U(I,J)
      VRES(I,J)=VRES(I,J)+V(I,J)
  715 CONTINUE
  714 CONTINUE



**************************Write hourly output****************
	 if(hw.eq.0) then      
	 


           write(10,57)z(201,70)
		 write(11,58)u(201,70),v(201,70)	



	 



************************write horizontal values ***************

         open(983,file='Tidal_fields_'//hhh//'.dat')
         write(*,*)'Tidal_fields_'//hhh//'.dat'
      
        do j=1,jm
	  do i=1,im


        write(983,984)i,j,alon(i,j),alat(i,j),u(i,j),v(i,j),z(i,j)
	
	
	  enddo
        enddo

        close(983)
        endif

  984 format(2i5,5f9.4)
   57 format(f10.5)
   58 format(f10.5,x,f10.5)


c	*********************end*******************
C	*******************************************

101	IF(N/10000*10000.NE.N) GOTO 100
c	write(*,*) N
C     COMPUTATION OF THE KINETIC ENERGY
      EK=0
      DO 410 I=2,IM-2
      DO 410 J=2,JM-2
  410 EK=EK+H(I,J)*((V(I,J)+V(I,J+1))**2+(U(I,J)+U(I+1,J))**2)/8
      WRITE(3,*)N,EK
c
	IF(N.LT.NM) GOTO 100



	stop
	End

